//
//  LivenessViewController.m
//  IDLFaceSDKDemoOC
//
//  Created by 阿凡树 on 2017/5/23.
//  Copyright © 2017年 Baidu. All rights reserved.
//

#import "LivenessViewController.h"
#import <IDLFaceSDK/IDLFaceSDK.h>

@interface LivenessViewController ()<AVSpeechSynthesizerDelegate>
{
    int voiceCount;
    BOOL isEnter;
}
@property (nonatomic, strong) NSArray * livenessArray;
@property (nonatomic, assign) BOOL order;
@property (nonatomic, assign) NSInteger numberOfLiveness;
@property (nonatomic, strong) NSMutableArray * arrayForImage;
@property(nonatomic,strong)AVSpeechSynthesizer *spe;
@property(nonatomic,strong)AVSpeechUtterance *utt;

@end

@implementation LivenessViewController



-(AVSpeechSynthesizer *)spe
{
    if (!_spe) {
        _spe =[AVSpeechSynthesizer new];
        _spe.delegate =self;
    }
    return _spe;
}
-(void)kankan_voice:(NSString*)stringValue{
    
    //增加语音说话次数和安全性
    if(isEnter==YES){
        isEnter=NO;
    self.utt =[AVSpeechUtterance speechUtteranceWithString:stringValue];
    self.utt.voice =[AVSpeechSynthesisVoice voiceWithLanguage:@"zh_CH"];
        if ([stringValue isEqualToString:@"请把脸移入圆框内"]) {
            voiceCount++;
            if (voiceCount <5) {
                [self.spe speakUtterance:self.utt];
            }
        }else{
             [self.spe speakUtterance:self.utt];
        }

        isEnter=YES;
    }
}
-(NSMutableArray *)arrayForImage
{
    if (!_arrayForImage) {
        _arrayForImage =[NSMutableArray array];
    }
    return _arrayForImage;
    
}
- (void)viewDidLoad {
    [super viewDidLoad];
    // 翻转
    UIButton* ButtonChange = [UIButton buttonWithType:UIButtonTypeCustom];
    [ButtonChange setBackgroundImage:[UIImage imageNamed:@"changCamera"] forState:UIControlStateNormal];
    [ButtonChange addTarget:self action:@selector(changCameraClick:) forControlEvents:UIControlEventTouchUpInside];
    ButtonChange.frame = CGRectMake( [UIScreen mainScreen ].bounds.size.width -50, 30, 30, 30);
    [self.view addSubview:ButtonChange];
    isEnter =YES;
    
}
-(void)changCameraClick:(UIButton*)sender{
        sender.selected = !sender.isSelected;
    if (sender.isSelected== YES) {
        self.videoCapture.position =AVCaptureDevicePositionBack;
    }else{
       self.videoCapture.position =AVCaptureDevicePositionFront;
    }
    
    
    
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [[IDLFaceLivenessManager sharedInstance] startInitial];
}

- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
    [IDLFaceLivenessManager.sharedInstance reset];
}

- (void)onAppBecomeActive {
    [super onAppBecomeActive];
    [[IDLFaceLivenessManager sharedInstance] livenesswithList:_livenessArray order:_order numberOfLiveness:_numberOfLiveness];
}

- (void)onAppWillResignAction {
    [super onAppWillResignAction];
    [IDLFaceLivenessManager.sharedInstance reset];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)livenesswithList:(NSArray *)livenessArray order:(BOOL)order numberOfLiveness:(NSInteger)numberOfLiveness {
    _livenessArray = [NSArray arrayWithArray:livenessArray];
    _order = order;
    _numberOfLiveness = numberOfLiveness;
    [[IDLFaceLivenessManager sharedInstance] livenesswithList:livenessArray order:order numberOfLiveness:numberOfLiveness];
}


+ (UIImage *)imagehuangzhuan:(UIImage *)image rotation:(UIImageOrientation)orientation
{
    long double rotate = 0.0;
    CGRect rect;
    float translateX = 0;
    float translateY = 0;
    float scaleX = 1.0;
    float scaleY = 1.0;
    
    switch (orientation) {
        case UIImageOrientationLeft:
            rotate = M_PI_2;
            rect = CGRectMake(0, 0, image.size.height, image.size.width);
            translateX = 0;
            translateY = -rect.size.width;
            scaleY = rect.size.width/rect.size.height;
            scaleX = rect.size.height/rect.size.width;
            break;
        case UIImageOrientationRight:
            rotate = 33 * M_PI_2;
            rect = CGRectMake(0, 0, image.size.height, image.size.width);
            translateX = -rect.size.height;
            translateY = 0;
            scaleY = rect.size.width/rect.size.height;
            scaleX = rect.size.height/rect.size.width;
            break;
        case UIImageOrientationDown:
            rotate = M_PI;
            rect = CGRectMake(0, 0, image.size.width, image.size.height);
            translateX = -rect.size.width;
            translateY = -rect.size.height;
            break;
        default:
            rotate = 0.0;
            rect = CGRectMake(0, 0, image.size.width, image.size.height);
            translateX = 0;
            translateY = 0;
            break;
    }
    
    UIGraphicsBeginImageContext(rect.size);
    CGContextRef context = UIGraphicsGetCurrentContext();
    //做CTM变换
    CGContextTranslateCTM(context, 0.0, rect.size.height);
    CGContextScaleCTM(context, 1.0, -1.0);
    CGContextRotateCTM(context, rotate);
    CGContextTranslateCTM(context, translateX, translateY);
    
    CGContextScaleCTM(context, scaleX, scaleY);
    //绘制图片
    CGContextDrawImage(context, CGRectMake(0, 0, rect.size.width, rect.size.height), image.CGImage);
    
    UIImage *newPic = UIGraphicsGetImageFromCurrentImageContext();
    
    return newPic;
}
- (void)faceProcesss:(UIImage *)image {
    if (self.hasFinished) {
        return;
    }
    
    __weak typeof(self) weakSelf = self;
  
    [[IDLFaceLivenessManager sharedInstance] livenessStratrgyWithImage:image previewRect:self.previewRect detectRect:self.detectRect completionHandler:^(NSDictionary *images, LivenessRemindCode remindCode) {
        switch (remindCode) {
            case LivenessRemindCodeOK: {
                
                //                NSString *targetPath_3333=[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0] stringByAppendingPathComponent:@"newss3"];
                
                [weakSelf.arrayForImage addObject:image];
                //                [weakSelf.arrayForImage addObject:[LivenessViewController imagehuangzhuan:image rotation:UIImageOrientationLeft]];
                
                if (weakSelf.arrayForImage.count >5) {
                    weakSelf.hasFinished = YES;
                    [weakSelf stopCapture];
                    [self warningStatus:CommonStatus warning:@"非常好"];
                    
                    if (images[@"bestImage"] != nil && [images[@"bestImage"] count] != 0) {
                        
                        NSData* data = [[NSData alloc] initWithBase64EncodedString:[images[@"bestImage"] lastObject] options:NSDataBase64DecodingIgnoreUnknownCharacters];
                        UIImage* bestImage = [UIImage imageWithData:data];
                        
                        
                        
                        
                        NSLog(@"bestImage = %@",bestImage);
                    }
                    if (images[@"liveEye"] != nil) {
                        NSData* data = [[NSData alloc] initWithBase64EncodedString:images[@"liveEye"] options:NSDataBase64DecodingIgnoreUnknownCharacters];
                        UIImage* liveEye = [UIImage imageWithData:data];
                        NSLog(@"liveEye = %@",liveEye);
                    }
                    if (images[@"liveMouth"] != nil) {
                        NSData* data = [[NSData alloc] initWithBase64EncodedString:images[@"liveMouth"] options:NSDataBase64DecodingIgnoreUnknownCharacters];
                        UIImage* liveMouth = [UIImage imageWithData:data];
                        NSLog(@"liveMouth = %@",liveMouth);
                    }
                    if (images[@"yawRight"] != nil) {
                        NSData* data = [[NSData alloc] initWithBase64EncodedString:images[@"yawRight"] options:NSDataBase64DecodingIgnoreUnknownCharacters];
                        UIImage* yawRight = [UIImage imageWithData:data];
                        NSLog(@"yawRight = %@",yawRight);
                    }
                    if (images[@"yawLeft"] != nil) {
                        NSData* data = [[NSData alloc] initWithBase64EncodedString:images[@"yawLeft"] options:NSDataBase64DecodingIgnoreUnknownCharacters];
                        UIImage* yawLeft = [UIImage imageWithData:data];
                        NSLog(@"yawLeft = %@",yawLeft);
                    }
                    if (images[@"pitchUp"] != nil) {
                        NSData* data = [[NSData alloc] initWithBase64EncodedString:images[@"pitchUp"] options:NSDataBase64DecodingIgnoreUnknownCharacters];
                        UIImage* pitchUp = [UIImage imageWithData:data];
                        NSLog(@"pitchUp = %@",pitchUp);
                    }
                    if (images[@"pitchDown"] != nil) {
                        NSData* data = [[NSData alloc] initWithBase64EncodedString:images[@"pitchDown"] options:NSDataBase64DecodingIgnoreUnknownCharacters];
                        UIImage* pitchDown = [UIImage imageWithData:data];
                        NSLog(@"pitchDown = %@",pitchDown);
                    }
                    
                    dispatch_async(dispatch_get_main_queue(), ^{
                        if (weakSelf.completion) {
                            weakSelf.spe =nil;
                            weakSelf.utt = nil;
                            [weakSelf.arrayForImage addObject:image];
                            //                            [weakSelf.arrayForImage addObject:[LivenessViewController imagehuangzhuan:image rotation:UIImageOrientationLeft]];
                            weakSelf.completion(images,weakSelf.arrayForImage);
                            [weakSelf.arrayForImage removeAllObjects];
                            [[NSUserDefaults standardUserDefaults ]setInteger:1 forKey:@"huoti_kankan_int"];
                            [[NSUserDefaults standardUserDefaults]synchronize];
                        }
                        [weakSelf closeAction];
                    });
                    self.circleView.conditionStatusFit = true;
                    [self singleActionSuccess:true];
                    break;
                }
            }
            case LivenessRemindCodePitchOutofDownRange:
                [self warningStatus:PoseStatus warning:@"建议略微抬头" conditionMeet:false];
                [self singleActionSuccess:false];
//                 [self kankan_voice:@"建议略微抬头"];
                break;
            case LivenessRemindCodePitchOutofUpRange:
                [self warningStatus:PoseStatus warning:@"建议略微低头" conditionMeet:false];
                [self singleActionSuccess:false];
//                [self kankan_voice:@"建议略微低头"];
                break;
            case LivenessRemindCodeYawOutofLeftRange:
                [self warningStatus:PoseStatus warning:@"建议略微向右转头" conditionMeet:false];
                [self singleActionSuccess:false];
//                [self kankan_voice:@"建议略微向右转头"];
                break;
            case LivenessRemindCodeYawOutofRightRange:
                [self warningStatus:PoseStatus warning:@"建议略微向左转头" conditionMeet:false];
                [self singleActionSuccess:false];
           //      [self kankan_voice:@"建议略微向左转头"];
                break;
            case LivenessRemindCodePoorIllumination:
                [self warningStatus:CommonStatus warning:@"光线再亮些" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeNoFaceDetected:
                [self warningStatus:CommonStatus warning:@"把脸移入框内" conditionMeet:false];
                [self singleActionSuccess:false];
              
                break;
            case LivenessRemindCodeImageBlured:
                [self warningStatus:CommonStatus warning:@"请保持不动" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeOcclusionLeftEye:
                [self warningStatus:occlusionStatus warning:@"左眼有遮挡" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeOcclusionRightEye:
                [self warningStatus:occlusionStatus warning:@"右眼有遮挡" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeOcclusionNose:
                [self warningStatus:occlusionStatus warning:@"鼻子有遮挡" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeOcclusionMouth:
                [self warningStatus:occlusionStatus warning:@"嘴巴有遮挡" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeOcclusionLeftContour:
                [self warningStatus:occlusionStatus warning:@"左脸颊有遮挡" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeOcclusionRightContour:
                [self warningStatus:occlusionStatus warning:@"右脸颊有遮挡" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeOcclusionChinCoutour:
                [self warningStatus:occlusionStatus warning:@"下颚有遮挡" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeTooClose:
                [self warningStatus:CommonStatus warning:@"手机拿远一点" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeTooFar:
                [self warningStatus:CommonStatus warning:@"手机拿近一点" conditionMeet:false];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeBeyondPreviewFrame:
                [self warningStatus:CommonStatus warning:@"把脸移入框内" conditionMeet:false];
                [self singleActionSuccess:false];
                  [self kankan_voice:@"请把脸移入圆框内"];
                break;
            case LivenessRemindCodeLiveEye:
                [self warningStatus:CommonStatus warning:@"眨眨眼" conditionMeet:true];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeLiveMouth:
                [self warningStatus:CommonStatus warning:@"请连续张嘴三次" conditionMeet:true];
                [self kankan_voice:@"请连续张嘴三次"];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeLiveYawRight:
                [self warningStatus:CommonStatus warning:@"向右缓慢转头" conditionMeet:true];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeLiveYawLeft:
                [self warningStatus:CommonStatus warning:@"向左缓慢转头" conditionMeet:true];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeLivePitchUp:
                [self warningStatus:CommonStatus warning:@"缓慢抬头" conditionMeet:true];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeLivePitchDown:
                [self warningStatus:CommonStatus warning:@"缓慢低头" conditionMeet:true];
                [self singleActionSuccess:false];
                 [self kankan_voice:@"请缓慢低头"];
                break;
            case LivenessRemindCodeLiveYaw:
                [self warningStatus:CommonStatus warning:@"摇摇头" conditionMeet:true];
                [self singleActionSuccess:false];
                break;
            case LivenessRemindCodeSingleLivenessFinished:
            {
                [self warningStatus:CommonStatus warning:@"非常好" conditionMeet:true];
                [self.arrayForImage addObject:image];
                //                    [weakSelf.arrayForImage addObject:[LivenessViewController imagehuangzhuan:image rotation:UIImageOrientationLeft]];
                [self singleActionSuccess:true];
            }
                break;
            case LivenessRemindCodeVerifyInitError:
                [self warningStatus:CommonStatus warning:@"验证失败，错误码‘28’"];
                break;
            case LivenessRemindCodeVerifyDecryptError:
                [self warningStatus:CommonStatus warning:@"验证失败，错误码‘29’"];
                break;
            case LivenessRemindCodeVerifyInfoFormatError:
                [self warningStatus:CommonStatus warning:@"验证失败，错误码‘30’"];
                break;
            case LivenessRemindCodeVerifyExpired:
                [self warningStatus:CommonStatus warning:@"验证失败，错误码‘31’"];
                break;
            case LivenessRemindCodeVerifyMissRequiredInfo:
                [self warningStatus:CommonStatus warning:@"验证失败，错误码’32‘"];
                break;
            case LivenessRemindCodeVerifyInfoCheckError:
                [self warningStatus:CommonStatus warning:@"验证失败，错误码’33‘"];
                break;
            case LivenessRemindCodeVerifyLocalFileError:
                [self warningStatus:CommonStatus warning:@"验证失败，错误码’34‘"];
                break;
            case LivenessRemindCodeVerifyRemoteDataError:
                [self warningStatus:CommonStatus warning:@"验证失败，错误码’35‘"];
                break;
            case LivenessRemindCodeTimeout: {
                dispatch_async(dispatch_get_main_queue(), ^{
                    UIAlertController* alert = [UIAlertController alertControllerWithTitle:@"检测超出时间请重新检测" message:nil preferredStyle:UIAlertControllerStyleAlert];
                    UIAlertAction* action = [UIAlertAction actionWithTitle:@"知道啦" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                        NSLog(@"知道啦");
                    }];
                    [alert addAction:action];
                    UIViewController* fatherViewController = weakSelf.presentingViewController;
                    [weakSelf dismissViewControllerAnimated:YES completion:^{
                        [fatherViewController presentViewController:alert animated:YES completion:nil];
                        [[NSUserDefaults standardUserDefaults ]setInteger:9999 forKey:@"huoti_kankan_int"];
                        [[NSUserDefaults standardUserDefaults]synchronize];
                    }];
                });
                break;
            }
            case LivenessRemindCodeConditionMeet: {
                self.circleView.conditionStatusFit = true;
            }
                break;
            default:
                break;
        }
    }];
}

- (void)warningStatus:(WarningStatus)status warning:(NSString *)warning conditionMeet:(BOOL)meet
{
    [self warningStatus:status warning:warning];
    self.circleView.conditionStatusFit = meet;
}

- (void)dealloc
{
    
}
@end

